//+------------------------------------------------------------------+
//|                               Scooby-doo Monica Rsi Overkill.mq4 |
//|               Opposite Rsi trade closing coding by Nick - swnke2 |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define long "Long"
#define short "Short"
#define none "None"


/*
www.forexpros.com
	

void DisplayUserFeedback()
void Printtxt(string text, string str,int size, string font, color vcolor = -1, double vertical = -1.0, int droite = 0) 

int start()
void GetPosition()
void DoesTradeExist(string symbol)
bool NewsExist()    not used in this robot
bool SendSingleTrade(int type, string symbol)
void SetStopLossTakeProfit(int type, string symbol, double price)
bool ShouldRobotSleep(string symbol)

----Rsi----
void GetRsi(string symbol)
void CheckCloseonOppRSI(string symbol)


----Trade management----
void ManageTrades()
void JumpingStopLoss(int ticket) 
bool CheckForHiddenStopLossHit(int type, int iPipsAboveVisual, double stop)
void ShouldHalfTradeClose()


----Pairs traded----
void CleanUpInputString()
void CalculatePairsPassed()

*/


extern string  PairsToTrade = "AUDCHF,AUDJPY,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURJPY,EURUSD,GBPCHF,GBPJPY,GBPUSD,USDCAD,USDCHF,USDJPY";
extern double  Lot = 0.2;
extern int     MagicNumber = 106422;
extern string  TradeComment="Monicas Twin";
extern int     MaxSpread=120;
extern bool    CriminalIsECN=false;
extern int     MaxTradesAllowed=6;
extern int     SleepAfterTradeClosesMins=60;
extern int     BEP=100;
extern string  rsit="----Rsi settings----";
extern int     Rsi_Period=2;
extern int     Rsi_Overbought=80;
extern int     Rsi_Oversold=20;
extern bool    Use_Rsi_M1=true;
extern bool    Use_Rsi_M5=true;
extern bool    Use_Rsi_M15=true;
extern bool    Use_Rsi_M30=true;
extern bool    Use_Rsi_H1=true;
extern bool    Use_Rsi_H4=true;
extern bool    Use_Rsi_D1=true;
extern bool    Use_Rsi_W1=true;
extern bool    Use_Rsi_MN1=true;
extern string  rsiclose="-Rsi settings for Close-";
extern string  rsni="Code courtesy of Nick - swnke2";
extern bool    UseOppRSIToClose = true;
extern bool    Close_Rsi_M1=true;
extern bool    Close_Rsi_M5=true;
extern bool    Close_Rsi_M15=true;
extern bool    Close_Rsi_M30=true;
extern bool    Close_Rsi_H1=true;
extern bool    Close_Rsi_H4=false;
extern bool    Close_Rsi_D1=false;
extern bool    Close_Rsi_W1=false;
extern bool    Close_Rsi_MN1=false;
extern string  sti="----Atr settings----";
extern string  stid="D1=1440: W1=10080: MN=40320";
extern int     Atr_Timeframe=1440;
extern int     Atr_Period=14;
extern double  Atr_TP_Multiplication_Factor=2;
extern string  trs="----Trading style----";
extern bool    SendImmediateMarketOrder=true;
extern bool    SendPendingOrder=false;
extern int     PendingOrderPips=100;
extern int     PendingOrderDeleteMins=120;
extern bool    LongTradeAllowed=true;//Allows user to disable trading
extern bool    ShortTradeAllowed=true;//Allows user to disable trading
extern bool    AlertNotTrade=false;
extern string  sls="----Trade management----";
extern string  JSL="Jumping stop loss";
extern bool    JumpingStop=false;
extern int     JumpingStopPips=1000;
extern bool    AddBEP=true;
extern int     BreakEvenProfit=100;
extern bool    HideJumpingStop=false;
extern int     PipsAwayFromVisualJS=100;
extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours 24hr";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 0;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 24;
extern string  wei="----Week ending inputs----";
extern bool    FridayClose=true;
extern bool    SaturdayClose=false;
extern int     CloseHour = 12;
extern string  dins="----Pair display settings----";
extern color   PairColour=Yellow;
extern color   OverboughtColour=Green;
extern color   OversoldColour=Red;
extern color   NeutralColour=Blue;
extern string  oae="----Odds and ends----";
extern int     DisplayGapSize=30;
extern bool    ShowPairsInformation=true;
                                    



//Open trades\trade direction.
bool     TradeExists;
int      TicketNo;
string   TradeDirection;
int      NoOfTrades;
double   StopLoss, TakeProfit;
   
//Rsi
int      Rsi_M1;
int      Rsi_M5;
int      Rsi_M15;
int      Rsi_M30;
int      Rsi_H1;
int      Rsi_H4;
int      Rsi_D1;
int      Rsi_W1;
int      Rsi_MN1;

//Trading hours
bool     ClosedForFriday;
bool     ClosedForSaturday;


//Pair extraction
string   InputString;//Holds the contents PairsToTrade for tidying yp etc
int      NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string   TradePair[]; //Array to hold the pairs traded by the user
int      dBars[];

//Rsi array
double   Rsi[], CloseRsi[];
string   ColHeadings[];

//Misc stuff
int      Decimals, OldBars;
string   Trend, ScreenMessage, Gap;
bool     RobotDisabled;
string   DisabledMessage;


void DisplayUserFeedback()
{

   ScreenMessage = "";
   int cc;
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading ", PairsToTrade, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "RSI settings: Period =  ", Rsi_Period, 
                   ": Over bought = ", Rsi_Overbought, ": Over sold = ", Rsi_Oversold, ": TP multiplication = ", Atr_TP_Multiplication_Factor);
   if (UseOppRSIToClose) ScreenMessage = StringConcatenate(ScreenMessage, ": Closing trades when Rsi reaches opposite extreme", NL);
   if (!UseOppRSIToClose) ScreenMessage = StringConcatenate(ScreenMessage, ": Not closing trades when Rsi reaches opposite extreme", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "ATR settings: Time frame =  ", Atr_Timeframe, 
                   ": Period = ", Atr_Period, ": Over sold = ", Rsi_Oversold, NL);
   if (!AlertNotTrade) 
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap);
      if (LongTradeAllowed) ScreenMessage = StringConcatenate(ScreenMessage, "Taking long trades: ");
      else  ScreenMessage = StringConcatenate(ScreenMessage, "Not taking long trades: ");
      if (ShortTradeAllowed) ScreenMessage = StringConcatenate(ScreenMessage, "Taking short trades: ");
      else ScreenMessage = StringConcatenate(ScreenMessage, "Not taking short trades: ");
   }//if (!AlertNotTrade)    
   ScreenMessage = StringConcatenate(ScreenMessage, "MaxTradesAllowed = ", MaxTradesAllowed, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lot);
   ScreenMessage = StringConcatenate(ScreenMessage, ":  Magic number: ", MagicNumber);
   ScreenMessage = StringConcatenate(ScreenMessage, ":  Trade comment: ", TradeComment);
   if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage, ":  CriminalIsECN is true ", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, ":  CriminalIsECN is false ", NL);
   if(start_hourm==0 && end_hourm==12 && start_houre==12 && end_houre==24)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "EA enabled for 24hr trading ", NL);
   }
   if(start_hourm!=0 || end_hourm!=12 || start_houre!=12 || end_houre!= 24)
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour start = ", start_hourm, NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour end = ", end_hourm, NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour start = ", start_houre, NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour end = ", end_houre, NL);
   }   
   if (FridayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Friday close = ", DoubleToStr(CloseHour, 2), NL);
   if (SaturdayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Saturday close = ", DoubleToStr(CloseHour, 2), NL);
   if (ClosedForSaturday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Saturday close. Continuing to monitor open trades.", NL);
   if (ClosedForFriday) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading suspended for Friday close. Continuing to monitor open trades.", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Pending pips distance = ", PendingOrderPips);
   ScreenMessage = StringConcatenate(ScreenMessage, ":   Pending trades expiry = ", PendingOrderDeleteMins, " minutes", NL);
   if (AlertNotTrade) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Robot will show an alert when there is a possible trade, but will not actively trade", NL);
   if(JumpingStop==true)
   {
      ScreenMessage = StringConcatenate(ScreenMessage,  Gap, "Jumping stop set to ", JumpingStopPips);
      if (HideJumpingStop)  ScreenMessage = StringConcatenate(ScreenMessage, " (HideJumpingStop = true: PipsAwayFromVisualJS = ", PipsAwayFromVisualJS, ")");
      if(AddBEP==true)
      {
         ScreenMessage = StringConcatenate(ScreenMessage, ", also adding BreakEvenProfit (", BreakEvenProfit, " pips)");      
      }      
   }
   else
   {
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Jumping stop disabled");
   }
   Comment(ScreenMessage);

   if (ShowPairsInformation)
   {
      int v_size=7;
      double vertical = 10.2;
      vertical+= 0.8;
      double horizontal = 150;
      string Label_Name;
      
      for (cc = 0; cc < ArraySize(ColHeadings); cc++)
      {
         Label_Name = "mylabel"+DoubleToStr(cc,0)+"col";         
         Printtxt(ColHeadings[cc],Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
         horizontal+= 20;
         
      }//for (cc = 0; cc < ArraySize(ColHeadings); cc++)
      
      for (cc = 0; cc < ArraySize(TradePair); cc++)
      {
         string symbol = TradePair[cc];
         
         horizontal = 60;
         color v_color=Yellow;
         vertical+= 0.8;
         Label_Name = "mylabel"+DoubleToStr(cc,0);
         Printtxt(symbol,Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
         horizontal = 150;
         
         GetRsi(symbol);
         //int digits = MarketInfo(symbol, MODE_DIGITS);
         
         for (int d = 0; d < ArraySize(Rsi); d++)
         //for (int d = 0; d < 2; d++)
         {
            string thisone;
            thisone = "N"; v_color = NeutralColour;
            if (Rsi[d] >= Rsi_Overbought) 
            {
               thisone = "OB"; 
               v_color = OverboughtColour;
            }//if (Rsi[d] >= Rsi_Overbought) 
            if (Rsi[d] <= Rsi_Oversold) 
            {
               thisone = "OS"; 
               v_color = OversoldColour;
            }//if (Rsi[d] <= Rsi_Oversold) 
            int iRsi_Val = Rsi[d];
            Label_Name = "mylabel"+DoubleToStr(cc,0) +"X"+ DoubleToStr(d,0);
            Printtxt(thisone, Label_Name, v_size,"Arial", v_color,vertical,horizontal);
            horizontal+= 20;
         }//for (int d = 0; d < ArraySize(Rsi); d++)
         
                 
                  
      }//for (cc = 0; cc < NoOfCurrencies; cc==)
   }//if (ShowPairsInformation)

   
}//End void DisplayUserFeedback()

void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 
{
   //if (ObjectFind(str) != 0)
   if (ObjectFind(str) == -1)
   {
      ObjectCreate(str, OBJ_LABEL, 0, 0, 0);      
   }
   ObjectSetText(str, text, size, font, vcolor);
   ObjectSet(str, OBJPROP_XDISTANCE, 0 + horizontal);
   ObjectSet(str, OBJPROP_YDISTANCE, 0 + 14.0 * vertical);
   
}//End void Printtxt(string text, string str,int size, string font, color vcolor = -1, double vertical = -1.0, int horizontal = 0) {

//+------------------------------------------------------------------+
//| expert Initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {

   if (!IsDemo() )
   {
      if (MagicNumber == 106422)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 106412." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 4872635)
      
      //Insufficient length
      string mn = DoubleToStr(MagicNumber,0);
      if (StringLen(mn) < 5)
      {
         MessageBox("Your MagicNumber input needs to be at least 5 digits long, Your MagicNumber is " + mn + NL 
                    + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to make the MagicNumber input at 5 digits long - more is better";
         RobotDisabled = true;
         return;
      }//if (StringLen(mn) < 5)     
      
   }//if (!IsDemo)
   
   
   //Amend inputs to cater for different broker digits
   int dig = MarketInfo(Symbol(), MODE_DIGITS);
   if (dig == 2 || dig == 4)
   {   
      PendingOrderPips/= 10;
      JumpingStopPips/= 10;
      BEP/= 10;
      MaxSpread/= 10;
   }//if (dig = 3)
   
   //Extract the pairs traded by the user
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the arrays appropriately
   string NewArray = ArrayResize(TradePair, NoOfPairs);
   double iNew3 = ArrayResize(dBars, NoOfPairs);
   int Rsi_Array_Size = 0;
   if (Use_Rsi_M1) Rsi_Array_Size++;
   if (Use_Rsi_M5) Rsi_Array_Size++;
   if (Use_Rsi_M15) Rsi_Array_Size++;
   if (Use_Rsi_M30) Rsi_Array_Size++;
   if (Use_Rsi_H1) Rsi_Array_Size++;
   if (Use_Rsi_H4) Rsi_Array_Size++;
   if (Use_Rsi_D1) Rsi_Array_Size++;
   if (Use_Rsi_W1) Rsi_Array_Size++;
   if (Use_Rsi_MN1) Rsi_Array_Size++;
   
   double iNew4 = ArrayResize(Rsi, Rsi_Array_Size);
   double sNew1 = ArrayResize(ColHeadings, Rsi_Array_Size);
   
// ---   
   int CloseRsi_Array_Size = 0;
   if (Close_Rsi_M1) CloseRsi_Array_Size++;
   if (Close_Rsi_M5) CloseRsi_Array_Size++;
   if (Close_Rsi_M15) CloseRsi_Array_Size++;
   if (Close_Rsi_M30) CloseRsi_Array_Size++;
   if (Close_Rsi_H1) CloseRsi_Array_Size++;
   if (Close_Rsi_H4) CloseRsi_Array_Size++;
   if (Close_Rsi_D1) CloseRsi_Array_Size++;
   if (Close_Rsi_W1) CloseRsi_Array_Size++;
   if (Close_Rsi_MN1) CloseRsi_Array_Size++;
   
   double iNew5 = ArrayResize(CloseRsi, CloseRsi_Array_Size);
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         TradePair[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         TradePair[cc] = StringTrimLeft(TradePair[cc]);
         TradePair[cc] = StringTrimRight(TradePair[cc]);
         TradePair[cc] = StringConcatenate(TradePair[cc], AddChar);
         
         LastIndex = Index+1;
         dBars[cc] = iBars(TradePair[cc], 0);         
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)

    int Step = MarketInfo(Symbol(),MODE_LOTSTEP);
    
    if(Step == 0.01) Decimals = 2;
    if(Step == 0.10) Decimals = 1;
    if(Step == 1.00) Decimals = 0;
    
    
   Gap="";
   if (DisplayGapSize >0)
   {
      for (cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }
   
   GetPosition();   
      
   Comment(".........Waiting for a tick");   
   DisplayUserFeedback();
   
   return(0);
    
  }
  
//+------------------------------------------------------------------+
//| expert Deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {

    Comment("");
    ObjectsDeleteAll();
    return(0);

  }
  
//+------------------------------------------------------------------+
//| expert GetPosition function                                      |
//+------------------------------------------------------------------+

void GetPosition()
{

   NoOfTrades = 0;
   if (OrdersTotal() == 0 ) return;
   
   for(int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
       if(!OrderSelect(cc, SELECT_BY_POS, MODE_TRADES) ) continue;
         
       if(OrderMagicNumber() == MagicNumber)
       {
           NoOfTrades++;
       }//if(OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)
         
   }//for(int cc = 0; cc <= OrdersTotal(); cc++)
 
 
}//void GetPosition(string symbol)



/*
//+------------------------------------------------------------------+
//| expert News function                                             |
//+------------------------------------------------------------------+  

bool NewsExist()
  {
  
    bool News;

    for(int d = 0; d < NoOfPairs; d++)
      {
        int MinutesSincePrevEvent =
          iCustom(NULL,0,"Economic News",TradePair[d],true,false,false,true,true,1,0);

        int MinutesUntilNextEvent =
          iCustom(NULL,0,"Economic News",TradePair[d],true,false,false,true,true,1,1);

        if(MinutesUntilNextEvent < 60 ||
           MinutesSincePrevEvent < 15)
          {
            News = true;
          }
      }
      
    return(News);

  }
*/
//+------------------------------------------------------------------+
//| expert Trend function                                            |
//+------------------------------------------------------------------+  


void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()





void ShouldHalfTradeClose()
{
   //Only called if selected trade is in profit/
   //Closes half the trade at profit of risk x 2
   
   if (!IsTradeAllowed() ) return;
   
   RefreshRates();
   double ask = MarketInfo(OrderSymbol(), MODE_ASK);
   double bid = MarketInfo(OrderSymbol(), MODE_BID);
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
   
   double atr = iATR(OrderSymbol(), Atr_Timeframe, Atr_Period, 0);

   string symbol = OrderSymbol();
   
   //Long
   if (OrderType() == 0)
   {
      double HcPrice = NormalizeDouble(OrderOpenPrice() + ((atr * Atr_TP_Multiplication_Factor)/2), digits); //Half close price

      if (ask > HcPrice)
      {
        bool result = OrderClose(OrderTicket(),OrderLots() / 2, OrderClosePrice(),100,CLR_NONE);
        if (!result)
        {
             int err=GetLastError();
             Alert(symbol, " Monica Rsi overkill robot ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
             return;
        }//if (!result)
        //Get new ticket number
        Sleep(100);
        DoesTradeExist(symbol );
        OrderSelect(TicketNo, SELECT_BY_TICKET);
        if (OrderStopLoss() < OrderOpenPrice() )
        {
           double SL = NormalizeDouble(OrderOpenPrice() + (BEP * point), digits);
           result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
           if (!result)
            {
                err=GetLastError();
                Alert(symbol, " Monica Rsi overkill robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                return;
            }//if (!result)     
        }//if (OrderStopLoss() < OrderOpenPrice() )
     }//if (Ask > HcPrice)      
   }//if (OrderType() == 0)
   
   //Short
   if (OrderType() == 1)
   {
      HcPrice = NormalizeDouble(OrderOpenPrice() - ((atr * Atr_TP_Multiplication_Factor)/2), digits); //Half close price
      if (bid < HcPrice)
      {
         result = OrderClose(OrderTicket(),OrderLots() / 2, OrderClosePrice(),100,CLR_NONE);
         if (!result)
         {
             err=GetLastError();
             Alert(symbol, " Monica Rsi overkill robot ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
             return;
         }//if (!result)
        //Get new ticket number
        Sleep(100);
        DoesTradeExist(symbol );
        OrderSelect(TicketNo, SELECT_BY_TICKET);
        if (OrderStopLoss() < OrderOpenPrice() )
        {
           SL = NormalizeDouble(OrderOpenPrice() - (BEP * point), digits);
           result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
           if (!result)
            {
                err=GetLastError();
                Alert(symbol, " Monica Rsi overkill robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
                return;
            }//if (!result)     
        }//if (OrderStopLoss() < OrderOpenPrice() ) 
      }//if (Bid < HcPrice)      
   }//if (OrderType() == 1)
   

}//void ShouldHalfTradeClose()


void ManageTrades()
{
   //Called if there are any open trades
   for (int cc = OrdersTotal() - 1; cc >=0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() ==  MagicNumber)
      {
         double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
         double point = MarketInfo(OrderSymbol(), MODE_POINT);
         TicketNo = OrderTicket();
         if (JumpingStop)
         {
            JumpingStopLoss(TicketNo);
         }//if (JumpingStop)
                 
         //Partial trade closure
         OrderSelect(TicketNo, SELECT_BY_TICKET);//Should not need re-selecting, but just in case
         if (OrderCloseTime() == 0 && OrderProfit() > 0 && OrderLots() == Lot)
         {
            ShouldHalfTradeClose();
         }//if (OrderCloseTime() == 0 && OrderProfit() > 0)
      
         //Pick up on any failed stop move to breakeven
         if (OrderType() == OP_BUY)
         {
            if (OrderLots() < Lot && OrderStopLoss() < OrderOpenPrice() )
            {
               OrderModify(TicketNo, OrderOpenPrice(), NormalizeDouble(OrderOpenPrice() + (BEP * point), digits), OrderTakeProfit(), OrderExpiration(), CLR_NONE);
            }//if (OrderLots() < Lot && OrderStopLoss() < OrderOpenPrice() )            
         }//if (OrderType() == OP_BUY)
         
         if (OrderType() == OP_SELL)
         {
            if (OrderLots() < Lot && OrderStopLoss() > OrderOpenPrice() )
            {
               OrderModify(TicketNo, OrderOpenPrice(), NormalizeDouble(OrderOpenPrice() - (BEP * point), digits), OrderTakeProfit(), OrderExpiration(), CLR_NONE);
            }//if (OrderLots() < Lot && OrderStopLoss() < OrderOpenPrice() )            
         }//if (OrderType() == OP_SELL)
         
      }//if (symbol == symbol && OrderMagicNumber() ==  MagicNumber)      
   }//for (int cc = OrdersTotal() - 1; cc >=0)

   
   
}//void ManageTrades()


void DoesTradeExist(string symbol)
{
   //Searches for open trades
   TradeExists = false;
   TicketNo = 0;
   
   
   if (OrdersTotal() == 0) return; //nothing to do
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol ) 
      {
         TicketNo = OrderTicket();
         TradeExists = true;
         return;         
      }//if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol)       
   }//for (int cc = OrdersTotal() - 1; cc >= 0, cc--)  
   
}//End void DoesTradeExist(string symbol)


bool ShouldRobotSleep(string symbol)
{
   // Checks the history list to find a closed trade.
   // If one exists, checks to see if it closed more than SleepAfterTradeClosesMins.
   // Returns false (sleep not needed) if so, else true (sleep needed)
   
   if (OrdersHistoryTotal() == 0) return(false);// No history trades, so sleep clearly not needed
   
   for(int cnt = 0; cnt < OrdersHistoryTotal(); cnt++)
   {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)) continue;
      {       
         if (OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber && OrderProfit() != 0)
         {
            int TimePassed = (TimeCurrent() - OrderCloseTime()) / 60;
            if (TimePassed < SleepAfterTradeClosesMins) return(true);//Robot should sleep
         }//if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)            
      }//if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY))
   }//for(int cnt=0; cnt<OrdersHistoryTotal(); cnt++)

   //Got this far, so sleep not needed
   return(false);

}//End bool ShouldRobotSleep(string symbol)

void SetStopLossTakeProfit(int type, string symbol, double price)
{
   double digits = MarketInfo(symbol, MODE_DIGITS);
   double atr = iATR(symbol, Atr_Timeframe, Atr_Period, 0);
   
   
   if (type == OP_BUY || type == OP_BUYSTOP)
   {
      StopLoss = NormalizeDouble(price - atr, digits );
      TakeProfit = NormalizeDouble(price + (atr * Atr_TP_Multiplication_Factor), digits );      
   }//if (type == 0)

   if (type == OP_SELL || type == OP_SELLSTOP)
   {      
      StopLoss = NormalizeDouble(price + atr, digits );
      TakeProfit = NormalizeDouble(price - (atr * Atr_TP_Multiplication_Factor), digits );      
   }//if (type == 0)


}//End void SetStopLossTakeProfit(int type, string symbol)

bool SendSingleTrade(int type, string symbol)
{
   // Attempts to place a trade according to type, i.e.
   // 0 = OP_BUY
   // 1 = OP_SELL
   
   // Check spread
   if (MarketInfo(symbol, MODE_SPREAD) > MaxSpread)
   {
      return(false);// Spread too large, so abort send
   }//if (MarketInfo(NULL, MODE_SPREAD) > MaxSpreadAllowed)
   
   RefreshRates();
   double ask = MarketInfo(symbol, MODE_ASK);
   double bid = MarketInfo(symbol, MODE_BID);
   double point = MarketInfo(symbol, MODE_POINT);
   double digits = MarketInfo(symbol, MODE_DIGITS);
   
      
   // Buy trade
   if (type == 0)
   {
      double TradePrice=ask;
      int colour = 32768;//green
      SetStopLossTakeProfit(0, symbol, TradePrice);
      datetime expiry = 0;
   }//if (type == 0)   
   
   //Buy stop trade
   if (type == OP_BUYSTOP)
   {
      TradePrice = NormalizeDouble(ask + (PendingOrderPips * point), digits);
      colour = 32768;//green
      expiry = TimeCurrent()+(PendingOrderDeleteMins*60);
      SetStopLossTakeProfit(0, symbol, TradePrice);
   }//if (type == 4)

   // Sell trade
   if (type == 1)
   {
      TradePrice=bid;      
      colour = 255;//red
      SetStopLossTakeProfit(1, symbol, TradePrice);
      expiry = 0;
   }//if (type == 1)
   
   //Sell stop trade
   if (type == OP_SELLSTOP)
   {
      TradePrice = NormalizeDouble(bid - (PendingOrderPips * point), digits);
      colour = 255;//red
      expiry = TimeCurrent()+(PendingOrderDeleteMins*60);
      SetStopLossTakeProfit(1, symbol, TradePrice);
   }//if (type == 4)
   
   int slippage = 10;
   if (digits == 3 || digits == 5) slippage = 100;
   
   if (!CriminalIsECN) int ticket = OrderSend(symbol,type, Lot, TradePrice, slippage, StopLoss, TakeProfit, TradeComment, MagicNumber,expiry, colour);
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      ticket = OrderSend(symbol,type, Lot, TradePrice, slippage, 0, 0, TradeComment, MagicNumber, expiry, colour);
	   if (StopLoss != 0)
	   {
		   if (ticket > 0)
		   bool result = OrderModify(ticket, OrderOpenPrice(), StopLoss, TakeProfit, 0, CLR_NONE);
		   if (!result)
		   {
		       int err=GetLastError();
             Alert("Monica Rsi Overkill ", symbol, " ", type," SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
		   }//if (!result)			  
	   }//if (Sl != 0)
      
      
   }//if (CriminalIsECN)

   if (ticket < 0)
   {
      err=GetLastError();
      if (err == 130) return;
      Alert("Monica Rsi Overkill ", symbol, " ", type," order send failed with error(",err,"): ",ErrorDescription(err));
      Print("Order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)
   else Sleep(1000);//1 second   
   
   return(true);
   
}//End bool SendSingleTrade(int type, string symbol)


bool CheckForHiddenStopLossHit(int type, int iPipsAboveVisual, double stop)
{
   //Reusable code that can be called by any of the stop loss manipulation routines except HiddenStopLoss().
   //Checks to see if the market has hit the hidden sl and attempts to close the trade if so. 
   //Returns true if trade closure is successful, else returns false

   RefreshRates();
   double ask = MarketInfo(OrderSymbol(), MODE_ASK);
   double bid = MarketInfo(OrderSymbol(), MODE_BID);
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
   
   //Check buy trade
   if (type == OP_BUY)
   {
      double sl = NormalizeDouble(stop + (iPipsAboveVisual * point), digits);
      if (bid <= sl)
      {
         bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            int err=GetLastError();
            Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (bid <= sl)  
   }//if (type = OP_BUY)
   
   //Check buy trade
   if (type == OP_SELL)
   {
      sl = NormalizeDouble(stop - (iPipsAboveVisual * point), digits);
      if (ask >= sl)
      {
         result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
         if (result)
         {
            Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket());      
         }//if (result)
         else
         {
            err=GetLastError();
            Alert("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
            Print("Stop loss hit. Close of ", OrderSymbol(), " ticket no ", OrderTicket()," failed with error (",err,"): ",ErrorDescription(err));
         }//else
      }//if (ask >= sl)  
   }//if (type = OP_SELL)
   

}//End bool CheckForHiddenStopLossHit(int type, int iPipsAboveVisual, double stop)

void JumpingStopLoss(int ticket) 
{
   if (!OrderSelect(ticket, SELECT_BY_TICKET) ) return;//Order has closed, so nothing to do

   RefreshRates();
   double ask = MarketInfo(OrderSymbol(), MODE_ASK);
   double bid = MarketInfo(OrderSymbol(), MODE_BID);
   double point = MarketInfo(OrderSymbol(), MODE_POINT);
   double digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
  
   double sl=OrderStopLoss(); //Stop loss

   if (OrderType()==OP_BUY)
   {
      //Check hidden js for trade closure
      if (HideJumpingStop)
      {
         bool TradeClosed = CheckForHiddenStopLossHit(OP_BUY, PipsAwayFromVisualJS, OrderStopLoss() );
         if (TradeClosed) return;//Trade has closed, so nothing else to do
      }//if (HideJumpingStop)
      
      // First check if sl needs setting to breakeven
      if (sl==0 || sl<OrderOpenPrice())
      {
         if (ask >= OrderOpenPrice() + (JumpingStopPips*point))
         {
            sl=OrderOpenPrice();
            if (AddBEP==true) sl=sl+(BreakEvenProfit*point); // If user wants to add a profit to the break even
            bool result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (result)
            {
               Print("Jumping stop set at breakeven: ", OrderSymbol(), ": SL ", sl, ": ask ", ask);
               //Delete the associated hedge trade
               return(0);
            }//if (result)
            if (!result)
            {
               int err=GetLastError();
               Alert(Symbol(), " buy trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
               Print(Symbol(), " buy trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
            }//if (!result)
             
            
         }//if (ask >= OrderOpenPrice() + (JumpingStopPips*point))
      } //close if (sl==0 || sl<OrderOpenPrice()

  
      // Increment sl by sl + JumpingStopPips.
      // This will happen when market price >= (sl + JumpingStopPips)
      if (bid>= sl + ((JumpingStopPips*2)*point) && sl>= OrderOpenPrice())      
      {
         sl=sl+(JumpingStopPips*point);
         result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
         if (result)
         {
            Print("Jumping stop set: ", OrderSymbol(), ": SL ", sl, ": ask ", ask);
            //Delete the associated hedge trade
            return(0);
         }//if (result)
         if (!result)
         {
            err=GetLastError();
            Print(Symbol(), " buy trade. Jumping stop function failed with error(",err,"): ",ErrorDescription(err));
         }//if (!result)
             
      }// if (bid>= sl + (JumpingStopPips*point) && sl>= OrderOpenPrice())      
   }//if (OrderType()==OP_BUY)
   
   if (OrderType()==OP_SELL)
   {
      //Check hidden js for trade closure
      if (HideJumpingStop)
      {
         TradeClosed = CheckForHiddenStopLossHit(OP_SELL, PipsAwayFromVisualJS, OrderStopLoss() );
         if (TradeClosed) return;//Trade has closed, so nothing else to do
      }//if (HideJumpingStop)
            
      // First check if sl needs setting to breakeven
      if (sl==0 || sl>OrderOpenPrice())
      {
         if (ask <= OrderOpenPrice() - (JumpingStopPips*point))
         {
            sl = OrderOpenPrice();
            if (AddBEP==true) sl=sl-(BreakEvenProfit*point); // If user wants to add a profit to the break even
            result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
            if (result)
            {
               
            }//if (result)
            if (!result)
            {
               err=GetLastError();
               Alert(Symbol(), " sell trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
               Print(Symbol(), " sell trade. Jumping stop function failed to set SL at breakeven, with error(",err,"): ",ErrorDescription(err));
            }//if (!result)
             
            return(0);
         }//if (ask <= OrderOpenPrice() - (JumpingStopPips*point))
      } // if (sl==0 || sl>OrderOpenPrice()
   
      // Decrement sl by sl - JumpingStopPips.
      // This will happen when market price <= (sl - JumpingStopPips)
      if (bid<= sl - ((JumpingStopPips*2)*point) && sl<= OrderOpenPrice())      
      {
         sl=sl-(JumpingStopPips*point);
         result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
         if (result)
         {
            Print("Jumping stop set: ", OrderSymbol(), ": SL ", sl, ": ask ", ask);
            
         }//if (result)          
         if (!result)
         {
            err=GetLastError();
            Print(Symbol(), " sell trade. Jumping stop function failed with error(",err,"): ",ErrorDescription(err));
         }//if (!result)

      }// close if (bid>= sl + (JumpingStopPips*point) && sl>= OrderOpenPrice())         
   }//if (OrderType()==OP_SELL)

} //End of JumpingStopLoss sub

void GetRsi(string symbol)
{
   //Reads rsi values and sets trade direction


   //Set up Rsi array 
   int cc = 0;
   
   //Read rsi values
   if (Use_Rsi_M1)
   {
      Rsi[cc] = iRSI(symbol, PERIOD_M1, Rsi_Period, PRICE_CLOSE, 0);
      ColHeadings[cc] = "M1";
      cc++;
   }
   
   if (Use_Rsi_M5)
   {
      Rsi[cc] = iRSI(symbol, PERIOD_M5, Rsi_Period, PRICE_CLOSE, 0);
      ColHeadings[cc] = "M5";
      cc++;
   }
   
   if (Use_Rsi_M15)
   {
      Rsi[cc] = iRSI(symbol, PERIOD_M15, Rsi_Period, PRICE_CLOSE, 0);
      ColHeadings[cc] = "M15";
      cc++;
   }
   
   if (Use_Rsi_M30)
   {
      Rsi[cc] = iRSI(symbol, PERIOD_M30, Rsi_Period, PRICE_CLOSE, 0);
      ColHeadings[cc] = "M30";
      cc++;
   }
   
   if (Use_Rsi_H1)
   {
      Rsi[cc] = iRSI(symbol, PERIOD_H1, Rsi_Period, PRICE_CLOSE, 0);
      ColHeadings[cc] = "M60";
      cc++;
   }
      
   if (Use_Rsi_H4)
   {
      Rsi[cc] = iRSI(symbol, PERIOD_H4, Rsi_Period, PRICE_CLOSE, 0);
      ColHeadings[cc] = "H4";
      cc++;
   }
      
   if (Use_Rsi_D1)
   {
      Rsi[cc] = iRSI(symbol, PERIOD_D1, Rsi_Period, PRICE_CLOSE, 0);
      ColHeadings[cc] = "D1";
      cc++;
   }
   
   if (Use_Rsi_W1)
   {
      Rsi[cc] = iRSI(symbol, PERIOD_W1, Rsi_Period, PRICE_CLOSE, 0);
      ColHeadings[cc] = "W1";
      cc++;
   }
   

   if (Use_Rsi_MN1)
   {
      Rsi[cc] = iRSI(symbol, PERIOD_MN1, Rsi_Period, PRICE_CLOSE, 0);
      ColHeadings[cc] = "MN1";
      cc++;
   }
   

   //Check for overbought   
   TradeDirection = short;
   bool overbought = true;
   for (cc = 0; cc < ArraySize(Rsi); cc++)
   {
      if (Rsi[cc] < Rsi_Overbought)
      {
         overbought = false;
         break;
      }//if (Rsi[cc] > Rsi_Overbought)   
   }//for (cc = 0; cc < NoOfPairs; cc++)
   if (overbought) return;
   
      
   //Check for oversold
   TradeDirection = long;
   bool oversold = true;
   for (cc = 0; cc < ArraySize(Rsi); cc++)
   {
      if (Rsi[cc] > Rsi_Oversold)
      {
         oversold = false;
         break;
      }//if (Rsi[cc] > Rsi_Overbought)   
   }//for (cc = 0; cc < NoOfPairs; cc++)
   if (oversold) return;
   

   //Got this far, so no clear trade direction has emerged
   TradeDirection = none;

      
}//End void GetRsi(string symbol)

void CheckCloseonOppRSI(string symbol)
{
   //Yhis code courtesy of Nick - swnke2. My thanks to Nick.
 
 //Set up Rsi array 
   int cc = 0;
   bool result;
   
   //Read rsi values
   if (Close_Rsi_M1)
   {
      CloseRsi[cc] = iRSI(symbol, PERIOD_M1, Rsi_Period, PRICE_CLOSE, 0);
      cc++;
   }
   
   if (Close_Rsi_M5)
   {
      CloseRsi[cc] = iRSI(symbol, PERIOD_M5, Rsi_Period, PRICE_CLOSE, 0);
      cc++;
   }
   
   if (Close_Rsi_M15)
   {
      CloseRsi[cc] = iRSI(symbol, PERIOD_M15, Rsi_Period, PRICE_CLOSE, 0);
      cc++;
   }
   
   if (Close_Rsi_M30)
   {
      CloseRsi[cc] = iRSI(symbol, PERIOD_M30, Rsi_Period, PRICE_CLOSE, 0);
      cc++;
   }
   
   if (Close_Rsi_H1)
   {
      CloseRsi[cc] = iRSI(symbol, PERIOD_H1, Rsi_Period, PRICE_CLOSE, 0);
      cc++;
   }
      
   if (Close_Rsi_H4)
   {
      CloseRsi[cc] = iRSI(symbol, PERIOD_H4, Rsi_Period, PRICE_CLOSE, 0);
      cc++;
   }
      
   if (Close_Rsi_D1)
   {
      CloseRsi[cc] = iRSI(symbol, PERIOD_D1, Rsi_Period, PRICE_CLOSE, 0);
      cc++;
   }
   
   if (Close_Rsi_W1)
   {
      CloseRsi[cc] = iRSI(symbol, PERIOD_W1, Rsi_Period, PRICE_CLOSE, 0);
      cc++;
   }
   

   if (Close_Rsi_MN1)
   {
      CloseRsi[cc] = iRSI(symbol, PERIOD_MN1, Rsi_Period, PRICE_CLOSE, 0);
      cc++;
   }
   

   bool CloseRSITradesShort = true;
   for (cc = 0; cc < ArraySize(CloseRsi); cc++)
   {
      if (CloseRsi[cc] > Rsi_Oversold)
      {
         CloseRSITradesShort = false;
         break;
      }//if (Rsi[cc] > Rsi_Overbought)   
   }//for (cc = 0; cc < NoOfPairs; cc++)
   
   
   bool CloseRSITradesLong = true;
   for (cc = 0; cc < ArraySize(CloseRsi); cc++)
   {
      if (CloseRsi[cc] < Rsi_Overbought)
      {
         CloseRSITradesLong = false;
         break;
      }//if (Rsi[cc] > Rsi_Overbought)   
   }//for (cc = 0; cc < NoOfPairs; cc++)
   
   
   if (CloseRSITradesShort == false && CloseRSITradesLong == false) return(0);
   
   for (cc=0; cc < OrdersTotal(); cc++)
	{
		if (OrderSelect(cc, SELECT_BY_POS, MODE_TRADES))
		{
         if (OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() )
         {
            if (OrderType() == OP_BUY  && CloseRSITradesLong  == true)  result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE);
            if (OrderType() == OP_SELL && CloseRSITradesShort == true)  result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5, CLR_NONE); 
         }
		} 
	} 
 
   
}//void CheckCloseonOppRSI(string symbol)



//+------------------------------------------------------------------+
//| expert Start function                                            |
//+------------------------------------------------------------------+

int start()
{
    
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )   

    GetPosition();
    if(NoOfTrades > 0) ManageTrades();
    
  
/*    //Trade disable conditions
    if (NewsExist() )
    {
         ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trading disabled because of news event");
         DisplayUserFeedback();
    }//if (NewsExists)
*/    

   
   //Trading hours
   bool TradeHour = false;
   if ((Hour()>=start_hourm && Hour()<end_hourm) || (Hour()>=start_houre && Hour()<end_houre)) TradeHour = true;
   if (!TradeHour)
   {
      Comment(Gap, "Trading suspended - outside trade hours. Continuing to monitor open trades.");
      return;
   }//if (!TradeHour)

    //Look for trading opportunities
    for(int cc = 0; cc < ArraySize(TradePair); cc++)
    {

      string symbol = TradePair[cc];//Does nothing more than make typing easier

      RefreshRates();
      double ask = MarketInfo(symbol, MODE_ASK);
      double bid = MarketInfo(symbol, MODE_BID);
      double point = MarketInfo(symbol, MODE_POINT);
      double digits = MarketInfo(symbol, MODE_DIGITS);
   
      
      //Check for open trades. Their ticket numbers are stored in variables set up for the purpose
      DoesTradeExist(symbol);

      if (UseOppRSIToClose)
         {
            CheckCloseonOppRSI(symbol);
         }
   
      //Check Friday close
     if (FridayClose)
     {
        ClosedForFriday = false;
        if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 5)
        {
           ClosedForFriday = true;
           DisplayUserFeedback();
           return;
        }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
     }//if (FridayClose)
        
     //Check Saturday close for Aitipodeans
     if (SaturdayClose)
     {
        ClosedForSaturday = false;
        if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 6)
        {
           ClosedForSaturday = true;
           DisplayUserFeedback();
           return;
        }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
     }//if (Saturday)

      //Check for sleep time after trade closure for any reason
      if (!TradeExists)
      {
         bool SendToSleep = ShouldRobotSleep(symbol);// Compares closure time of history trade with current time, 
                                               // returning true for sleep or false. Will return false if no history trades
         if (SendToSleep)
         {
            continue;
         }//if (SendToSleep)
      
      }//if (!LongOpen && !ShortOpen)
   
      if(NoOfTrades >= MaxTradesAllowed) break;

       if (!IsTradeAllowed())
       {
            Comment("Trading disabled by the criminal pillock. Please wait for him to get out of bed.");
            return;
       }//if (!IsTradeAllowed)
       
       if(iClose(TradePair[cc],0,0) > 0)
       {      
            
            if (TradeExists) continue;
            //Overriding filters ok, so continue
            bool TradeAllowed = true;
            if (TradeExists) TradeAllowed = false;
            
            //Check Rsi
            //Will return long all tf's are oversold, short if overbought, or none if not all tf's match up
            GetRsi(symbol);
            
            //Abort if trading has been disallowed for any reason
            if (!TradeAllowed) continue;
            
            if (IsTradeAllowed() )
            {                
               if (TradeDirection == long && LongTradeAllowed)
               {
                  if (AlertNotTrade) Alert("Monica Rsi Overkill ", symbol, " Long trade is available");
                  else
                  {
                     if (SendImmediateMarketOrder) SendSingleTrade(0, symbol);
                     if (SendPendingOrder) SendSingleTrade(OP_BUYSTOP, symbol);
                     NoOfTrades++;
                  }//else               
               }//if (Ask - HighestSma > 10 * Point) TradeDirection = long;
      
               if (TradeDirection == short && ShortTradeAllowed)
               {
                  if (AlertNotTrade) Alert("Monica Rsi Overkill ", symbol, " Short trade is available");
                  else
                  {               
                     if (SendImmediateMarketOrder) SendSingleTrade(1, symbol);
                     if (SendPendingOrder) SendSingleTrade(OP_SELLSTOP, symbol);
                     NoOfTrades++;
                  }//else
               }//if (Ask - HighestSma > 10 * Point) TradeDirection = long;         
               
            }//if (IsTradeAllowed)        
      
         }//if(iClose(TradePair[cc],0,0) > 0)
      
      }//for(int cc = 0; cc < ArraySize(TradePair); cc++)
    
    DisplayUserFeedback();
      
    return(0);

}//End start()


